# All files / src/custom-nodes/string-array-nodes StringArrayNode.ts

100% Statements 20/20
50% Branches 1/2
100% Functions 1/1
100% Lines 17/17

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    811x
    1x

    1x

    1x

    1x

    1x

    1x

    1x

    1x

    1x

    530x

    530x
    530x
    530x

    527x

    527x

    527x

     import { injectable, inject } from 'inversify';
    import { ServiceIdentifiers } from '../../container/ServiceIdentifiers';

    import * as format from 'string-template';

    import { TStatement } from '../../types/node/TStatement';

    import { IOptions } from '../../interfaces/options/IOptions';
    import { IStorage } from '../../interfaces/storages/IStorage';

    import { initializable } from '../../decorators/Initializable';

    import { StringArrayTemplate } from '../../templates/custom-nodes/string-array-nodes/string-array-node/StringArrayTemplate';

    import { AbstractCustomNode } from '../AbstractCustomNode';
    import { StringArrayStorage } from '../../storages/string-array/StringArrayStorage';

    @injectable()
    export class StringArrayNode extends AbstractCustomNode {
        /**
         * @type {IStorage <string>}
         */
        @initializable()
        private stringArrayStorage: IStorage <string>;

        /**
         * @type {string}
         */
        @initializable()
        private stringArrayName: string;

        /**
         * @type {number}
         */
        @initializable()
        private stringArrayRotateValue: number;

        /**
         * @param options
         */
        constructor (
            @inject(ServiceIdentifiers.IOptions) options: IOptions
        ) {
            super(options);
        }

        /**
         * @param stringArrayStorage
         * @param stringArrayName
         * @param stringArrayRotateValue
         */
        public initialize (
            stringArrayStorage: IStorage <string>,
            stringArrayName: string,
            stringArrayRotateValue: number
        ): void {
            this.stringArrayStorage = stringArrayStorage;
            this.stringArrayName = stringArrayName;
            this.stringArrayRotateValue = stringArrayRotateValue;
        }

        /**
         * @returns {TStatement[]}
         */
        public getNode (): TStatement[] {
            (<StringArrayStorage>this.stringArrayStorage).rotateArray(this.stringArrayRotateValue);

            return super.getNode();
        }

        /**
         * @returns {string}
         */
        protected getTemplate (): string {
            return format(StringArrayTemplate(), {
                stringArrayName: this.stringArrayName,
                stringArray: this.stringArrayStorage.toString()
            });
        }
    }